#ifndef SOFTWAREPARMELA_SEEN
#define SOFTWAREPARMELA_SEEN

#include "abstractSoftware.h"

class softwareParmela : public abstractSoftware
{

 protected : 


  
  //    les elements de parmela sont indexes à partir du premier, il faut 
  // donc prevoir un offset pour le raccord a pspa
  //  unsigned offsetNumElem_;

    vector<int> relativeParmelaElementIndices__deprecated;


  bool beamFromParmela(string workingDir,unsigned numeroElement, double referencefrequency, vector<double>& centroid, bareParticle& refPart,vector<bareParticle>& particles );

  bool beamToParmela(string workingDir, particleBeam* partic );
  void setRelativeParmelaElementIndices_deprecated();


  string elementsData(const vector< pair<string, vector<string> > >& donnees) const ;

  string rfgunData(const vector< pair<string, vector<string> > >& donnees) const;
  string cellData(const vector< pair<string, vector<string> > >& donnees) const;
  string driftData(const vector< pair<string, vector<string> > >& donnees) const;
  string solenoData(const vector< pair<string, vector<string> > >& donnees) const;
  string bendData(const vector< pair<string, vector<string> > >& donnees) const;


 public : 
    softwareParmela();
    
    softwareParmela(string inputFileName, sectionToExecute*, dataManager*);

  virtual ~softwareParmela() {;}


  virtual bool createInputFile(particleBeam* beamBefore, string workingDir);

  virtual bool  execute(string workingDir);


virtual bool buildBeamAfterElements(string workingDir);

    inline string getColor() {
        return "#e09bdf";
    }

    /* inline string getName() const { */
    /*     return "parmela"; */
    /* } */

};
#endif
